<!DOCTYPE html>
<html>

<head>
  <title>List of orders</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">

  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
   <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  

</head>

<body>

  <div class="wrapper">

      <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-controlsidebar-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/photo4.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Hung Tran</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
                with font-awesome or any other icon font library -->
            <li class="nav-item ">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <div class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1 class="m-0">Dashboard</h1>
              </div><!-- /.col -->
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Dashboard v1</li>
                </ol>
              </div><!-- /.col -->
            </div><!-- /.row -->
          </div><!-- /.container-fluid -->
        </div>
        <!-- /.content-header -->
      
        <!-- Main content -->

          <!-- List of orders -->
          <div class="container">
            <h1 style="text-align: center;">LIST OF ORDERS</h1>
            <div class="container jumbotron">
              <div class="row">
                <label class="col-sm-2 col-form-label">Order's status</label>
                <div class="col-sm-3">
                  <select id="select-order-status" class="form-control">
                    <option value="all">(All)</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirmed</option>
                    <option value="cancel">Cancel</option>
                  </select>
                </div>
                <label class="col-sm-2 col-form-label">Type of pizza</label>
                <div class="col-sm-3">
                  <select id="select-pizza" class="form-control">
                    <option value="all">(All)</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                  </select>
                </div>
                <button class="btn btn-primary col-sm-2" id="btn-filter-orders">Search</button>
              </div>
            </div>
            <div class="form-group">
              <button id="insert-new-order" class="btn btn-success">Insert new order</button>
            </div>
            <table class="table table-bordered table-striped table-hover" id="order-table">
              <thead>
                <tr>
                  <th>No.</th>
                  <th>Order Code</th>
                  <th>Combo (size)</th>
                  <th>Type of pizza</th>
                  <th>Drink</th>
                  <th>Amount</th>
                  <th>Name</th>
                  <th>Phone</th>
                  <th>Order's status</th>
                  <th>Detail</th>
                </tr>
            </table>
          </div>
        

          <!-- Modal for inserting a new order -->
          <div>
            <div id="insert-order-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">New order !!!</h5>
                      <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-combo">Pizza Size <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <select type="select" id="insert-combo" name="combo" class="form-control">
                                <option value="non-combo-selected">select combo</option>
                                <option value="Small">Small</option>
                                <option value="Medium">Medium</option>
                                <option value="Large">Large</option>
                              </select>
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-duong-kinh">Diameter</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-diameter" class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-suon">Grilled Ribs</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-grilled-ribs" class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-salad">Salad</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-salad" class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-so-luong-nuoc-uong">Quantity of drink</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-drink-quantity" class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-pizza">Pizza Type <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <select type="select" id="insert-pizza" name="pizza" class="form-control">
                                <option value="non-pizza-selected">select pizza</option>
                                <option value="Hawaii">Hawaii</option>
                                <option value="Bacon">Bacon</option>
                                <option value="Seafood">Seafood</option>
                              </select>
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-drink">Drink <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <select type="select" id="insert-drink" name="drink" class="form-control">
                                <option value="non-drink-selected">select drink</option>
                              </select>
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-thanh-tien">Price</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-price" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-voucher-code">Voucher code</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-voucher-code" name="voucherCode" placeholder="...."
                                class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-discount">Discount</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-discount" name="discount" placeholder="...."
                                class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-payment">Payment</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" disabled id="insert-payment" name="payment" placeholder="...."
                                class="form-control">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-name">Name <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-name" name="name" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-email">Email</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-email" name="email" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-phone">Phone <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-phone" name="phone" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-address">Address <span style="color: red;">(*)</span></label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-address" name="address" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-message">Message</label>
                            </div>
                            <div class="col-sm-8">
                              <input type="text" id="insert-message" name="message" class="form-control" placeholder="....">
                            </div>
                          </div>
                          <div class="row form-group">
                            <div class="col-sm-4">
                              <label for="insert-order-status">Order's status</label>
                            </div>
                            <div class="col-sm-8">
                              <select id="insert-order-status" class="form-control">
                                <option value="open">Open</option>
                              </select>
                            </div>
                          </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                      <div class="row form-group">
                        <div class="col-sm-6">
                          <button class="col-sm-12 btn btn-primary" id="btn-insert">Insert</button>
                          
                        </div>
                        <div class="col-sm-6">
                          <button class="col-sm-12 btn btn-danger" id="btn-insert-cancel" data-dismiss="modal">Cancel</button>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
            </div>
          </div> 
          
          <!-- Modal for editing-->
          <div>
            <div id="edit-order-modal" class="modal fade " tabindex="-1">
              <div class="modal-dialog ">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Order's Detail!!!</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-order-code">Order Code</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-order-code" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="select-combo">Pizza Size</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="select-combo" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-duong-kinh">Diameter</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-duong-kinh" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-suon">Grilled Ribs</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-suon" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-salad">Salad</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-salad" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="pizza-type">Pizza Type</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="pizza-type" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-id-voucher">Id Voucher</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-id-voucher" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-thanh-tien">Amount</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-thanh-tien" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-giam-gia">Discount</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-giam-gia" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="select-drink">Drink</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="select-drink" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-so-luong-nuoc-uong">Quantity of drink</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-so-luong-nuoc-uong" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-name">Name</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-name" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-email">Email</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-email" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-phone">Phone</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-phone" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-dia-chi">Address</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-dia-chi" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-message">Message</label>
                        </div>
                        <div class="col-sm-8">
                          <input type="text" disabled id="input-message" class="form-control">
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="input-order-status">Order's status</label>
                        </div>
                        <div class="col-sm-8">
                          <select type="text" id="input-order-status" class="form-control">
                            <option value="open">Open</option>
                            <option value="confirmed">Confirmed</option>
                            <option value="cancel">Cancel</option>
                          </select>
                        </div>
                      </div>
                      <div class="form-group text-right">
                        <div class="col-sm-12">
                          <button class="col-sm-3 btn btn-success" id="btn-confirm">Confirm/Cancel</button> &nbsp
                          <button class="col-sm-3 btn btn-primary" id="btn-close" data-dismiss="modal">Return</button>
                        </div>
                      </div>
                    </form>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <!-- Modal for deleting-->
          <div>
            <div id="delete-order-modal" class="modal fade " tabindex="-1">
              <div class="modal-dialog ">
                <div class="modal-content bg-warning">
                  <div class="modal-body">
                    <form>
                      <div class="form-group">
                        <div class="col-sm-12 ">
                          <h3 for="input-order-code">Are you sure to delete this order? </h3>
                        </div>
                      </div>
                      <div class="form-group text-right">
                        <div class="col-sm-12">
                          <button class="col-sm-3 btn btn-success" id="btn-delete">Delete</button> &nbsp
                          <button class="col-sm-3 btn btn-primary" id="btn-close" data-dismiss="modal">Cancel</button>
                        </div>
                      </div>
                    </form>
                  </div>
                </div>
              </div>
            </div>
          </div>

      <!-- /.content-wrapper -->
      <footer class="main-footer">
        <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
        All rights reserved.
        <div class="float-right d-none d-sm-inline-block">
          <b>Version</b> 3.2.0
        </div>
      </footer>
  </div>
</body>

<script>
  "use strict";
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  
    const gCOMBO_SMALL = "Small";
    const gCOMBO_MEDIUM = "Medium";
    const gCOMBO_LARGE = "Large";
    const gPIZZA_HAWAI = "Hawai";
    const gPIZZA_SEAFOOD = "Seafood";
    const gPIZZA_BACON = "Bacon";  
    const gBASE_URL_DRINK = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
    const gBASE_URL_VOUCHER = "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail";
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrderId = "";
    var gOrderCode = "";
    var gOrderStatus = "";
    var gOrderObj = "" ;
    var gVoucherCode = "";

    var gOrdersArr = [];
    const gCOLUMN_STT = 0;
    const gCOLUMN_CODE = 1;
    const gCOLUMN_COMBO = 2;
    const gCOLUMN_PIZZA = 3;
    const gCOLUMN_DRINK = 4;
    const gCOLUMN_AMOUNT = 5;
    const gCOLUMN_NAME = 6;
    const gCOLUMN_PHONE = 7;
    const gCOLUMN_ORDER_STATUS = 8;
    const gCOLUMN_DETAIL = 9;
    var gSTT = 0;

    const gUSER_COL = ["Stt", "orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "detail"]
    
    // set and mapping data table
    var gOrderTable = $("#order-table").DataTable({
      "columns": [
        { "data": gUSER_COL[gCOLUMN_STT] },
        { "data": gUSER_COL[gCOLUMN_CODE] },
        { "data": gUSER_COL[gCOLUMN_COMBO] },
        { "data": gUSER_COL[gCOLUMN_PIZZA] },
        { "data": gUSER_COL[gCOLUMN_DRINK] },
        { "data": gUSER_COL[gCOLUMN_AMOUNT] },
        { "data": gUSER_COL[gCOLUMN_NAME] },
        { "data": gUSER_COL[gCOLUMN_PHONE] },
        { "data": gUSER_COL[gCOLUMN_ORDER_STATUS] },
        { "data": gUSER_COL[gCOLUMN_DETAIL] }
      ],
      
      "columnDefs": [
        {
          "targets": gCOLUMN_STT, 
          "className": "text-center text-primary",
          render: function () {
                  gSTT++;
                  return gSTT;}
        },
        {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": `
            <i title="Edit" class="fa-solid fa-pen-to-square edit-order" style="color:blue"></i>
            <i title="Delete" class="fa-solid fa-trash delete-order" style="color:red"></i>
            `
        }]
    });

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
   
    onPageLoading();
    
    //add event on loading the drink list
    getDrinkListAjaxClick();
    
    // add event for the insert modal button
    $("#insert-new-order").on('click', function(){
          onInsertModalClick(this);
        })

    // add event for the insert confirm button
    $("#btn-insert").on('click', function(){
      onButtonInsertConfirm(this);
    })

    //add event for the filter button
    $("#btn-filter-orders").click(function () {
      onBtnFilterOrderClick();
    });

    // add event for the edit modal button
    $("#order-table").on("click", ".edit-order", function () {
      onButtonDetailClick(this); 
    });

    // add event for the edit-confirm button
    $("#btn-confirm").on("click", function () {
          onButtonConfirmClick(this); 
    });

    // add event for the delete modal button
    $("#order-table").on("click", ".delete-order", function () {
      onButtonDeleteClick(this); 
    });

    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    // function for loading page
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        dataType: 'json',
        success: function (responseObject) {
          //debugger;
          gOrdersArr = responseObject;
          loadDataToTable(responseObject);
        },
        error: function (error) {
          console.assert(error.responseText);
        }
      });
    }
    
    //function for Filter Button
    function onBtnFilterOrderClick() {
      var vFilterObj = {
        trangThai: "",
        loaiPizza: ""
      };
      
      getDataForFilter(vFilterObj);
      
      var vOrdersResult = filterOrders(vFilterObj);
      
      loadDataToTable(vOrdersResult);
    }
    
    //function to call API for getting orderCode
    function getAjaxDetailOrder(paramOrderCode) {
      "use strict";
      $.ajax({
        url: gBASE_URL + "/" + paramOrderCode,
        type: "GET",
        dataType: 'json',
        success: function (responseObject) {
          //debugger;
          console.log(responseObject);
          gOrderObj = responseObject;
          handleOrderDetail(responseObject);
          
        },
        error: function (error) {
          console.assert(error.responseText);
        }
      });
    }
    
    //function to get data of a row
    function getDataOfARow(paramRow){
      var vRowSelected = $(paramRow).parents('tr');
      var vDatatableRow = gOrderTable.row(vRowSelected);
      var vOrderData = vDatatableRow.data();

      gOrderId = vOrderData.id;
      gOrderCode = vOrderData.orderCode;
      gOrderStatus = vOrderData.trangThai;
      //return gOrderId
    }
        
    //function for Detail Modal
    function onButtonDetailClick(paramDetailButton) {
     
      getDataOfARow(paramDetailButton);
      console.log("Order id: " + gOrderId);
      console.log("Order code: " + gOrderCode);
      console.log("Order status: " + gOrderStatus);
     
      getAjaxDetailOrder(gOrderCode);
      $("#edit-order-modal").modal("show");
    }

    //function for Confirm Button
    function onButtonConfirmClick() {
      "use strict";
      console.log("id của đơn hàng là: " + gOrderId);
      var vEditOrderStatus = $("#input-order-status").find(':selected').val();
      console.log("edit: " + vEditOrderStatus )
     
      var vObjectRequest = {
        trangThai: vEditOrderStatus 
      }; 
      var vJsonString = JSON.stringify(vObjectRequest);
      
      getAjaxUpdateOrderStatus(gOrderId, vJsonString);
      
      if (vEditOrderStatus == "confirmed"){
        alert("Order  " + gOrderCode + "  has been confirmed!"); 
      }
      if (vEditOrderStatus == "cancel"){
        alert("Order  " + gOrderCode + "  has been cancelled!"); 
      }
      $("#edit-order-modal").modal("hide");
    }
    
    //funtion for Delete Modal
    function onButtonDeleteClick(paramDeleteButton){
      console.log("clicked");
      $("#delete-order-modal").modal("show");

      getDataOfARow(paramDeleteButton);
      console.log("Order id: " + gOrderId);
      console.log("Order code: " + gOrderCode);
      console.log("Order status: " + gOrderStatus);
    
      onButtonDeleteConfirm(gOrderId)
    }

    //funtion for Delete confirmation
    function onButtonDeleteConfirm(paramData){
      getAjaxDeleteOrder(paramData);
      $("#delete-order-modal").modal("hide");
    }

    //function for Insert Modal
    function onInsertModalClick(){
      $("#insert-order-modal").modal('show')
     
      $("#insert-combo").change(function () {
        var vComboSize = $("#insert-combo").find(':selected').val();
        var vComboSelected = "";

        if (vComboSize === gCOMBO_SMALL){
          $("#insert-diameter").val(20);
          $("#insert-grilled-ribs").val(2);
          $("#insert-salad").val(200);
          $("#insert-drink-quantity").val(2);
          $("#insert-price").val(150000);
          $("#insert-payment").val(150000);
        }
        if (vComboSize == gCOMBO_MEDIUM){
          $("#insert-diameter").val(25);
          $("#insert-grilled-ribs").val(4);
          $("#insert-salad").val(300);
          $("#insert-drink-quantity").val(3);
          $("#insert-price").val(200000);
          $("#insert-payment").val(200000);
        }
        if (vComboSize == gCOMBO_LARGE){
          $("#insert-diameter").val(30);
          $("#insert-grilled-ribs").val(8);
          $("#insert-salad").val(500);
          $("#insert-drink-quantity").val(4);
          $("#insert-price").val(250000);
          $("#insert-payment").val(250000);
        }
      });

      $("#insert-voucher-code").change(function () {
        var vVoucherCode = $("#insert-voucher-code").val();
            console.log(vVoucherCode)

        getVoucherCode(vVoucherCode)

        //calcualte the final payment

        var vPaymentObject = {
            priceVND: $("#insert-price").val(),
            percenDiscount: gVoucherCode.phanTramGiamGia,
            
            discountVND(){
              return (this.priceVND * this.percenDiscount/100)
            },
            
            finalPaymentVND(){
            return (1 - this.percenDiscount/100) * this.priceVND},
          };
          
        if (vVoucherCode != ""){
          if (gVoucherCode.maVoucher == vVoucherCode){
              vPaymentObject.percenDiscount = gVoucherCode.phanTramGiamGia;
          }
          if (gVoucherCode === 0){
              vPaymentObject.percenDiscount = 0;
          }
        }
        if (vVoucherCode == "" ){
            vPaymentObject.percenDiscount = 0;
        } 
        
        $("#insert-discount").val(vPaymentObject.discountVND());
        $("#insert-payment").val(vPaymentObject.finalPaymentVND());
      
      })
   }

    //funtion for Insert Click button
    function onButtonInsertConfirm(){
      
      //create the new order object
      var vNewOrderObject = {
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          loaiPizza: "",
          idVourcher: "",
          thanhTien: "",
          giamGia: "",
          idLoaiNuocUong: "",
          soLuongNuoc: "",
          hoTen: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: "",
          trangThai: "",
      };
      
      //get input data from the modal
      getDataNewOrderModal(vNewOrderObject);
      console.log(vNewOrderObject);
      //validate the input data
      var vValidRes = validateDataInsertModal(vNewOrderObject);
      
      if (vValidRes){
        getAjaxInserNewOrder(vNewOrderObject);
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    
    // load data to table
    function loadDataToTable(paramResponseObject) {
      gSTT = 0;
      gOrderTable.clear();
      gOrderTable.rows.add(paramResponseObject);
      gOrderTable.draw();
    }
    
    //function to get input data for Filter Button
    function getDataForFilter(paramFilterObj) {
      paramFilterObj.trangThai = $("#select-order-status").find(':selected').val();
      paramFilterObj.loaiPizza = $("#select-pizza").find(':selected').val();;
    }
    
    //function for filtering purpose
    function filterOrders(paramFilterObj) {
      var vOrders = [];
      vOrders = gOrdersArr.filter(function (paramOrder) {
        return ((paramOrder.trangThai == paramFilterObj.trangThai || paramFilterObj.trangThai == "all")
          && (paramOrder.loaiPizza == paramFilterObj.loaiPizza || paramFilterObj.loaiPizza == "all"));
      });
      return vOrders;
    }
    
    //function to call API for getting the drink list
    function getDrinkListAjaxClick() {
      "use strict";
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
        dataType: "json",
        type: "GET",
        success: function (res) {
          console.log(res);
          handleDrinkList(res);
          loadDataDrinkList(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        }
      });
    }
    
    //function for loading the drink list to select
    function handleDrinkList(paramDrink) {
      "use strict";
      var vArrayDrinkList = paramDrink;
      //load data to drink select
      var vSelectDrink = document.getElementById("select-drink");
      for (var bI = 0; bI < vArrayDrinkList.length; bI++) {
        var vDrinkOption = document.createElement("option");
        vDrinkOption.value = vArrayDrinkList[bI].maNuocUong;
        vDrinkOption.text = vArrayDrinkList[bI].tenNuocUong;
        vSelectDrink.appendChild(vDrinkOption);
      }
    }
    
    //function for order detail modal
    function handleOrderDetail(paramOrderObj) {
      "use strict";
      $("#input-order-code").val(paramOrderObj.orderCode);
      $("#select-combo").val(paramOrderObj.kichCo);
      $("#input-duong-kinh").val(paramOrderObj.duongKinh);
      $("#input-suon").val(paramOrderObj.suon);
      $("#input-salad").val(paramOrderObj.salad);
      $("#pizza-type").val(paramOrderObj.loaiPizza);
      $("#input-id-voucher").val(paramOrderObj.idVourcher);
      $("#input-thanh-tien").val(paramOrderObj.thanhTien);
      $("#input-giam-gia").val(paramOrderObj.giamGia);
      $("#select-drink").val(paramOrderObj.idLoaiNuocUong);
      $("#input-so-luong-nuoc-uong").val(paramOrderObj.soLuongNuoc);

      $("#input-name").val(paramOrderObj.hoTen);
      $("#input-email").val(paramOrderObj.email);
      $("#input-phone").val(paramOrderObj.soDienThoai);
      $("#input-dia-chi").val(paramOrderObj.diaChi);
      $("#input-message").val(paramOrderObj.loiNhan);

      $("#input-order-status").val(paramOrderObj.trangThai);
      
    }
    
    //function to call API for updating confirm status
    function getAjaxUpdateOrderStatus(paramOrderId, paramJsonString) {
      $.ajax({
        url: gBASE_URL + "/" + paramOrderId,
        data: paramJsonString,
        type: "PUT",
        contentType: "application/json", 
        success: function (paramResponse) {
          /*alert("Order Id: " + paramResponse.id + "status is updated succesfully!");
          console.log("%cUPDATED INFORMATION: ", "color:orange");
          console.log(paramResponse);*/
        },
        error: function (error) {
          console.assert(error.responseText);
        }
      });
    }
  
    //function to call API for deleting an order
    function getAjaxDeleteOrder(paramOrderId){

      $.ajax({
        url: gBASE_URL + "/" + gOrderId,
        type: "DELETE",
        success: function(res){
          //alert("The order ID: " + gOrderId + " has been deleted !!!");
          
        },
        error: function(ajaxContext){
          console.log(ajaxContext.status);
        }
      });
    }
 
    //function to call API for inserting a new order
    function getAjaxInserNewOrder(paramOrder){
      //debugger;
        $.ajax({
        url: gBASE_URL, 
        type: "POST",
        contentType: "application/json",
        data: JSON.stringify(paramOrder),
        success: function(res){
            console.log(res);
            handleSuccessInsert(res.orderCode);
        },
        error: function(ajacContext){
            console.log(ajacContext.status);
        }
      })
    };
  
    //function for getting voucher code
    function getVoucherCode(paramVoucher){
        //var paramVoucher = "12332"
        $.ajax({
            url: gBASE_URL_VOUCHER + "/" + paramVoucher,
            type: "GET",
            async: false,
            success: function(res){
                console.log(res);
                gVoucherCode = res;
                //console.log(gVoucherCode);
                return gVoucherCode;
            },
            error: function(ajaxContext){
                console.log(ajaxContext.status)
                console.log("Không tìm thấy voucher " + paramVoucher);
                
                gVoucherCode = 0
                alert("The voucher code: " + paramVoucher+ " is not found")
                return gVoucherCode;
            }
        })
    }

    //load data to the insert modal
    function loadDataDrinkList(paramDrink){
        //console.log(paramDrink);
        for (var index = 0; index < paramDrink.length; index++){
            var vDrinkSelect = $("#insert-drink");
            var vNewOption = new Option ("Option Text", "Option Value");
                vNewOption.value = paramDrink[index].maNuocUong;
                vNewOption.text = paramDrink[index].tenNuocUong;
            vDrinkSelect.append(vNewOption);
        };
    }

    //function for create the new order
    function getDataNewOrderModal(paramOrderObj){

      paramOrderObj.kichCo = $("#insert-combo").find(':selected').val();
      paramOrderObj.duongKinh = $("#insert-diameter").val();
      paramOrderObj.suon = $("#insert-grilled-ribs").val();
      paramOrderObj.salad = $("#insert-salad").val();
      paramOrderObj.loaiPizza = $("#insert-pizza").find(':selected').val();
      paramOrderObj.idVourcher = $("#insert-voucher-code").val();
      paramOrderObj.idLoaiNuocUong = $("#insert-drink").find(':selected').val();
      paramOrderObj.soLuongNuoc = $("#insert-drink-quantity").val();
      paramOrderObj.thanhTien = $("#insert-price").val();
      paramOrderObj.giamGia = $("#insert-discount").val();
      paramOrderObj.hoTen = $("#insert-name").val();
      paramOrderObj.email = $("#insert-email").val();
      paramOrderObj.soDienThoai = $("#insert-phone").val();
      paramOrderObj.diaChi = $("#insert-address").val();
      paramOrderObj.loiNhan = $("#insert-message").val();
      paramOrderObj.trangThai = $("#insert-order-status").find(':selected').val();
    }

    //validate the collected data
    function validateDataInsertModal(paramData){
        
        if (paramData.kichCo == "non-combo-selected"){
            alert("Choose the COMBO please!!!");
            return false;
        }
        if (paramData.loaiPizza == "non-pizza-selected"){
            alert("Choose the PIZZA please!!!");
            return false;
        }      
        if (paramData.idLoaiNuocUong == "non-drink-selected"){
            alert("Choose the DRINK please!!!");
            return false;
        }
        if (paramData.hoTen == ""){
            alert("Input the NAME please !!!");
            return false;
        }
        if (validateEmail(paramData.email) === false){
            return false;
        }
        if (paramData.soDienThoai == ""){
            alert("Input the PHONE please !!!");
            return false;
        }
        if (isNaN(paramData.soDienThoai) == true){
            alert("The phone must be number !!!");
            return false;
        }
        if (paramData.diaChi == ""){
            alert("Input ADDRESS please !!!");
            return false;    
        }
        return true;
    }

    //email checking
    function validateEmail(paramEmail){
        if (paramEmail.indexOf("@") === -1){
          alert("Email must have '@' !!!");
          return false;
        }
        if (paramEmail.startsWith("@") === true){
          alert("Characters are required before '@' !!!");
          return false;
        }
        if (paramEmail.endsWith("@") === true){
          alert("Characters are required after '@' !!!");
          return false;
        }
        if (paramEmail.indexOf(".") === -1){
          alert("Email must have dot (.) !!!");
          return false;
        }
        return true
    }

    //function for handling the successfull insert
    function handleSuccessInsert(paramOrderCode){
      alert("The orderCode  " + paramOrderCode + "  has been created successfully");
      onPageLoading();
      resetDataNewOrderModal();
      $("#insert-order-modal").modal("hide");
    }

    //function to reset the new order modal
    function resetDataNewOrderModal(){

      $("#insert-combo").val("non-combo-selected");
      $("#insert-diameter").val("");
      $("#insert-grilled-ribs").val("");
      $("#insert-salad").val("");
      $("#insert-pizza").val("non-pizza-selected");
      $("#insert-voucher-code").val("");
      $("#insert-drink").val("non-drink-selected");
      $("#insert-drink-quantity").val("");
      $("#insert-price").val("");
      $("#insert-discount").val("");
      $("#insert-payment").val("");
      $("#insert-name").val("");
      $("#insert-email").val("");
      $("#insert-phone").val("");
      $("#insert-address").val("");
      $("#insert-message").val("");
      $("#insert-order-status").find(':selected').val("");
    }
  });

</script>


<!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<!-- AdminLTE dashboard demo (This is only for demo purposes) -->
<script src="dist/js/pages/dashboard.js"></script>

</html>